MCA<-function(x,y)
{
#  x<-Observed;
# y<-Modeled;
# cm: Value of the metric CMA
# How to call the function:
# x<-runif(100)
# y<-x*runif(100)
# cm<-MCA(x,y)
# cm
  
  n<-length(x) # %sample size of the observed data
  
  #creating empty variables to hold computed values
  A <- matrix(nrow=n, ncol=1)
  B <- matrix(nrow=n, ncol=1)
  C <- matrix(nrow=n, ncol=1)
  D <- matrix(nrow=n, ncol=1)
  wx <- matrix(nrow=n, ncol=1)
  ux <- matrix(nrow=n, ncol=1)
  Dx <- matrix(nrow=n, ncol=1)
  wy <- matrix(nrow=n, ncol=1)
  uy <- matrix(nrow=n, ncol=1)
  Dy <- matrix(nrow=n, ncol=1)
  tDx <- matrix(nrow=n, ncol=1)
  tDy <- matrix(nrow=n, ncol=1)
  tDxy <- matrix(nrow=n, ncol=1)
  h <- matrix(nrow=n, ncol=1)
  
  # COMPUTING THE PARAMETRIC COMPONENT OF THE MODEL EFFICIENCY
  # **********************************************************
      x_mean<-mean(x) #% Mean of observed series
      
      # Penalty-based series derived from y or modeled series
      for (i in 1:n)
      {
        if (x[i]<0 & y[i]>=0) 
        { h[i]=0 }
        else if (x[i]>0 & y[i]<=0)
        {h[i]=0}
        else
        {h[i]=y[i]}
      }

      for (i in 1:n)
      {
         A[i]= (min(x[i],h[i])-2*x_mean)^2;
         B[i]= (max(x[i],h[i])-2*x_mean)^2; 
         C[i]= min (A[i],B[i]);
         D[i]= max (A[i],B[i])
      }
    
      if (sum(D)==0 | sum(h)==0)
        { beta1=0 }
      else
      { beta1=(sum(C)/sum(D)) }
      
    #TRANSFORMATION OF OBSERVED SERIES
      for (i in 1:n)
      {
         wx[i]=sum(x==x[i])  #counting how many times a data point x(i) appears in observed series X
         ux[i]=sum(x>x[i])   #counting how many times a given value x(i) is exceeded from an array X
         Dx[i]=n-wx[i]-2*ux[i] #this is the transformed observed series
      }    
   
    #TRANSFORMATION OF MODELED SERIES
      for (i in 1:n)
      {
        wy[i]=sum(y==y[i]) #counting how many times a data point y(i) appears in from an array y
        uy[i]=sum(y>y[i])  #counting how many times a given value y(i) is exceeded from an array y
        Dy[i]=n-wy[i]-2*uy[i] #this is the transformed modeled series
      }
      
      for (i in 1:n)
      {
        tDx[i]=(Dx[i])^2
        tDy[i]=(Dy[i])^2
        tDxy[i]=Dx[i]*Dy[i]
      }
      
    #Computing non-parametric trend slope and CMA
      if (sum(tDx==0) | sum(tDy==0))
      { rc=0 }
     else
      { rc=sum(tDxy)/sqrt(sum(tDx)*sum(tDy)) }
    
      cm =(rc)^2*beta1^2
      
    return(cm)
}
    